#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXN = 1e5;
const int MAXV = 1e9;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<pair<int, int>> tax, vector<int> q) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << tax.size() << endl;
    for (int i = 0; i < (int)tax.size(); i++)
        cout << tax[i].first << ' ' << tax[i].second << endl;
    cout << q.size() << endl;
    for (int i = 0; i < (int)q.size(); i++)
        cout << q[i] << endl;
}

void gen_rand(int n, int m, int maxv)
{
    vector<pair<int, int>> tax(n);
    vector<int> q(m);
    vector<int> b(n), t(n);
    map<int, int> used;
    b[0] = 0;
    used[0] = 1;
    t[0] = rnd.next(0, maxv);
    for (int i = 1; i < n; i++)
    {
        b[i] = rnd.next(0, maxv);
        while (used[b[i]])
            b[i] = (b[i] + 1) % maxv;
        used[b[i]] = 1;
        t[i] = rnd.next(0, maxv);
    }
    sort(b.begin(), b.end());
    sort(t.begin(), t.end());
    for (int i = 0; i < n; i++)
        tax[i] = make_pair(b[i], t[i]);
    for (int i = 0; i < m; i++)
        q[i] = rnd.next(1, maxv);
    write_test(tax, q);
}

void gen_special(int n, int maxv)
{
    assert(3*n <= MAXN);
    vector<pair<int, int>> tax(n);
    vector<int> q;
    vector<int> b(n), t(n);
    map<int, int> used;
    b[0] = 0;
    used[0] = 1;
    t[0] = rnd.next(0, maxv);
    for (int i = 1; i < n; i++)
    {
        b[i] = rnd.next(0, maxv);
        while (used[b[i]])
            b[i] = (b[i] + 1) % maxv;
        used[b[i]] = 1;
        t[i] = rnd.next(0, maxv);
    }
    sort(b.begin(), b.end());
    sort(t.begin(), t.end());
    for (int i = 0; i < n; i++)
        tax[i] = make_pair(b[i], t[i]);
    for (int i = 0; i < n; i++)
    {
        if (tax[i].first > 0)
            q.push_back(tax[i].first);
        if (tax[i].first > 1)
            q.push_back(tax[i].first - 1);
        if (tax[i].first < maxv)
            q.push_back(tax[i].first + 1);
    }
    shuffle(q.begin(), q.end());
    write_test(tax, q);
}


void gen_max(int n, int m, int maxv)
{
    vector<pair<int, int>> tax(n);
    vector<int> q(m);
    vector<int> b(n), t(n);
    map<int, int> used;
    b[0] = 0;
    used[0] = 1;
    t[0] = maxv;
    for (int i = 1; i < n; i++)
    {
        b[i] = maxv - n + i;
        t[i] = maxv;
    }
    sort(b.begin(), b.end());
    sort(t.begin(), t.end());
    for (int i = 0; i < n; i++)
        tax[i] = make_pair(b[i], t[i]);
    for (int i = 0; i < m; i++)
        q[i] = rnd.next(max(1, maxv / 10), maxv);
    write_test(tax, q);
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    for (int i = 10; i <= MAXN; i *= 10)
    {
        gen_rand(rnd.next(i / 2, i), rnd.next(i / 2, i), i * 10);
        gen_rand(rnd.next(i / 2, i), i, i * 10);
        gen_rand(i, i, i * 100);

        gen_special(rnd.next(i / 6, i / 3), i * 10);
        gen_special(i / 3, i * 100);
        
    } 
    gen_special(MAXN/3, MAXV);
    gen_rand(1, MAXN, MAXV);
    gen_rand(MAXN, MAXN, MAXV);
    gen_max(MAXN, MAXN, MAXV); 
    return 0;
}