#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

struct point {
	ll x, y;
	point(ll _x, ll _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

const int MAXC = 1'000'000'000;

int sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	vector<point> points;
	for (int i = 0; i < n; ++i) {
		points.push_back({inf.readInt(), inf.readInt()});
	}

	auto check_outp = [&](auto& stream) {
		int m = stream.readInt(0, INF, "m");
		vector<pair<point, point>> lines;
		for (int i = 0; i < m; ++i) {
			int x1 = stream.readInt(-MAXC, MAXC, format("x_{%d, 1}", i + 1));
			int y1 = stream.readInt(-MAXC, MAXC, format("y_{%d, 1}", i + 1));
			int x2 = stream.readInt(-MAXC, MAXC, format("x_{%d, 2}", i + 1));
			int y2 = stream.readInt(-MAXC, MAXC, format("y_{%d, 2}", i + 1));
			lines.push_back({point(x1, y1), point(x2, y2)});
			for (int j = 0; j < n; ++j) {
				if (cross(lines[i].ss - lines[i].ff, points[j] - lines[i].ff) == 0) {
					stream.quitf(_wa, "%d-th points lies on %d-th line", j + 1, i + 1);
				}
			}
		}

		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				bool ok = false;
				for (int k = 0; k < m; ++k) {
					if (sign(cross(lines[k].ss - lines[k].ff, points[i] - lines[k].ff)) != sign(cross(lines[k].ss - lines[k].ff, points[j] - lines[k].ff))) {
						ok = true;
						break;
					}
				}

				if (!ok) {
					stream.quitf(_wa, "%d-th and %d-th points are not divided by any line", i + 1, j + 1);
				}
			}
		}
		return m;
	};

	int jans = check_outp(ans);
	int pans = check_outp(ouf);

	if (jans < pans) {
		quitf(_wa, "participant found answer with %d lines, but jury did with %d", pans, jans);
	}

	if (jans > pans) {
		quitf(_fail, "jury found answer with %d lines, but participant did with %d", jans, pans);
	}

	quitf(_ok, "participant found correct answer with %d lines", pans);

	return 0;
}