#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

struct point {
	ll x, y;
	point() {}

	point(ll _x, ll _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator*(ll num) const {
		return point(x * num, y * num);
	}

	point ort() const {
		return point(y, -x);
	}
};

ostream& operator<<(ostream& o, point p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

const int MAXC = 1000;
const int MAXN = 12;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int maxc = atoi(argv[2]);

	assert(n % 2 == 0);

	vector<point> all;
	for (int x = -maxc; x <= maxc; ++x) {
		for (int y = -maxc; y <= maxc; ++y) {
			if ((x == 0 && y == 0) || __gcd(abs(x), abs(y)) != 1) {
				continue;
			}
			all.push_back(point(x, y));
		}
	}

	sort(all.begin(), all.end(), [&](auto& p1, auto& p2) {
		bool fl1 = p1.y > 0 || (p1.y == 0 && p1.x > 0);
		bool fl2 = p2.y > 0 || (p2.y == 0 && p2.x > 0);
		if (fl1 != fl2) {
			return fl1 < fl2;
		}
		return cross(p1, p2) > 0;
	});

	while (true) {
		int pos = rnd.next(0, szof(all) - 1);
		vector<point> poly = {point(0, 0)};
		for (int sign : {1, -1}) {
			for (int i = 0; i < n / 2; ++i) {
				poly.push_back(poly.back() + all[(pos + i) % szof(all)] * sign);
			}
		}
		poly.pop_back();
		ll minx = INF, maxx = -INF;
		ll miny = INF, maxy = -INF;
		for (auto p : poly) {
			minx = min(minx, p.x);
			maxx = max(maxx, p.x);
			miny = min(miny, p.y);
			maxy = max(maxy, p.y);
		}
		if (maxx - minx <= MAXC * 2 && maxy - miny <= MAXC * 2) {
			cout << n << "\n";
			for (auto p : poly) {
				cout << p.x << " " << p.y << "\n";
			}
			break;
		}
	}

	return 0;
}