// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

template <typename T>
struct vec {
    T x;
    T y;

    bool operator<(vec other) const {
        return false;
    };
};

template <typename T>
vec<T> operator+(vec<T> a, vec<T> b) {
    return vec<T> {a.x + b.x, a.y + b.y};
}

template <typename T>
vec<T> operator-(vec<T> a, vec<T> b) {
    return vec<T> {a.x - b.x, a.y - b.y};
}

template <typename T>
vec<T> operator*(T x, vec<T> a) {
    return vec<T> {x * a.x, x * a.y};
}

int64_t cross(vec<int> a, vec<int> b) {
    return a.x * (int64_t)b.y
        -  a.y * (int64_t)b.x;
}

int64_t dot(vec<int> a, vec<int> b) {
    return a.x * b.x + a.y * (int64_t)b.y;
}

namespace  std {
    template<>
    struct hash <vector<char>> {
        size_t operator()(const vector<char>& a) const {
            size_t res = 0;
            for (int i = 0; i < a.size(); ++i)
                res = 13 * res + a[i];

            return res;
        }
    };
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int n = input<int>();

    vector<vec<int>> in(n);
    for (vec<int>& v: in)
        cin >> v.x >> v.y;

    vector<pair<int, pair<vec<int>, vec<int>>>> lines;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            if (i != j) {
                int msk = 0;

                vec<int> dr = (in[j] - in[i]);
                
                vec<int> a = in[i] - 100000 * dr;
                vec<int> b = in[j] + 100000 * dr;

                if (dr.y > 0)
                    a.x += 1, b.x -= 1;
                else if (dr.y < 0)
                    a.x -= 1, b.x += 1;
                else if (dr.x > 0)
                    a.y -= 1, b.y += 1;
                else if (dr.x < 0)
                    a.y += 1, b.y -= 1;

                bool fl = false;
                for (int t = 0; t < n; ++t) {
                    if (cross(b - a, in[t] - a) > 0) {
                        msk |= (1 << t);
                    } else {
                        fl = fl or cross(b - a, in[t] - a) == 0;
                    }
                }

                assert(msk & (1 << i));
                assert(not (msk & (1 << j)));

                if (fl) {
                    continue;
                    //cerr << "fl\n";
                }
                
                int all = (1 << n) - 1;
                if (msk > (all ^ msk))
                    msk ^= all;

                lines.emplace_back(msk, make_pair(a, b));
            }

    sort(ALL(lines));
    lines.resize(std::unique(ALL(lines), [&](pair<int, pair<vec<int>, vec<int>>> a, pair<int, pair<vec<int>, vec<int>>> b) {
        return a.first == b.first;
    }) - lines.begin());

    auto compress = [&](vector<char>& st) {
        for (int i = SZ(st) - 1; i >= 0; --i) {
            int j;
            for (j = 0; j < i and st[j] != st[i]; ++j) {}

            st[i] = j;
        }
    };

    queue<vector<char>> qu;
    std::unordered_map<vector<char>, pair<vector<char>,int>> used(int(1e6));

    vector<char> st0(n);

    qu.emplace(st0);
    used[st0] = make_pair(vector<char>(), -1);

    while (not qu.empty()) {
        auto st = qu.front();
        qu.pop();
        
        if (std::accumulate(ALL(st), int(0)) == n * (n - 1) / 2) {
            vector<pair<vec<int>, vec<int>>> res;

            while (st != st0) {
                auto x = used[st];
                res.emplace_back(lines[x.second].second);
                st = x.first;
            }

            cout << SZ(res) << "\n";
            for (auto elem: res)
                cout << elem.first.x << " " << elem.first.y << " " << elem.second.x << " " << elem.second.y << "\n";
            return 0;
        }

        for (int i = 0; i < SZ(lines); ++i) {
            auto new_st = st;
            
            for (int p = 0; p < n; ++p)
                new_st[p] += 100 * ((lines[i].first & (1 << p)) != 0);

            compress(new_st);

            if (new_st == st)
                continue;
            if (used.count(new_st))
                continue;
            
            used[new_st] = make_pair(st, i);
            qu.emplace(new_st);
        }
    }
    
    
    return 0;
}
