// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
// #  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct point {
	ll x, y;
	point() {}

	point(ll _x, ll _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator*(ll num) const {
		return point(x * num, y * num);
	}

	point ort() const {
		return point(y, -x);
	}
};

ostream& operator<<(ostream& o, point p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

const int MAXC = 1'000'000'000;

void solve() {
	int n;
	cin >> n;
	vector<point> points;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		points.push_back({x, y});
	}

	auto encode = [&](vector<int> const& arr) {
		ll ret = 0;
		for (int i = 0; i < n; ++i) {
			ret = ret * n + arr[i];
		}
		return ret;
	};

	auto decode = [&](ll val, vector<int>& arr) {
		for (int i = n - 1; i >= 0; --i) {
			arr[i] = val % n;
			val /= n;
		}
	};

	map<int, pair<point, point>> lines;

	auto add_line = [&](point const& p1, point const& p2) {
		int mask = 0;
		int mem = -1;
		int best = INF;
		for (int k = 0; k < n; ++k) {
			int val = cross(p2 - p1, points[k] - p1);
			if (val >= 0) {
				mask |= 1 << k;
			} else {
				if (abs(val) < best) {
					best = abs(val);
					mem = k;
				}
			}
		}
		// cerr << p1 << " " << p2 << " " << mask << endl;
		if (mask & 1) {
			mask ^= (1 << n) - 1;
		}
		if (mask == 0 || lines.count(mask)) {
			return;
		}
		
		point c = p1;
		point v = p2 - p1;
		ll l = 0, r = 1e13;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			point cur = c + v * mid;
			if (abs(cur.x) <= MAXC && abs(cur.y) <= MAXC) {
				l = mid;
			} else {
				r = mid;
			}
		}
		point a = c + v * l;
		l = 0, r = 1e13;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			point cur = points[mem] - v * mid;
			if (abs(cur.x) <= MAXC && abs(cur.y) <= MAXC) {
				l = mid;
			} else {
				r = mid;
			}
		}
		point b = points[mem] - v * l;
		// cerr << a << " " << b << endl;
		int mask2 = 0;
		for (int k = 0; k < n; ++k) {
			// cerr << points[k] << " " << (b - a) << " " << (points[k] - a) << endl;
			ll val = cross(b - a, points[k] - a);
			// cerr << k << " " << val << endl;
			assert(val != 0);
			if (val > 0) {
				mask2 |= 1 << k;
			}
		}
		if (mask2 & 1) {
			mask2 ^= (1 << n) - 1;
		}
		// cerr << mask << " " << mask2 << endl;
		assert(mask == mask2);
		lines[mask] = {a, b};
	};

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i == j) {
				continue;
			}
			add_line(points[i], points[j]);
			add_line(points[i], points[i] + (points[j] - points[i]).ort());
			add_line(points[i], points[i] - (points[j] - points[i]).ort());
		}
	}

	cerr << szof(lines) << endl;

	queue<ll> qu;
	unordered_map<ll, pair<int, ll>> from;
	from[0] = {-1, -1};
	qu.push(0);
	vector<int> st(n), next_st(n);
	vector<vector<pii>> color(2, vector<pii>(n));
	int used_cnt = 123;
	while (szof(qu)) {
		ll cur = qu.front();
		qu.pop();
		decode(cur, st);
		if (*max_element(st.begin(), st.end()) == n - 1) {
			break;
		}
		for (auto& p : lines) {
			++used_cnt;
			int cnt = 0;
			for (int i = 0; i < n; ++i) {
				auto& cc = color[(p.ff >> i) & 1][st[i]];
				if (cc.ff != used_cnt) {
					cc.ff = used_cnt;
					cc.ss = cnt++;
				}
				next_st[i] = cc.ss;
			}
			ll to = encode(next_st);
			if (!from.count(to)) {
				from[to] = {p.ff, cur};
				qu.push(to);
			}
		}
	}

	cerr << szof(from) << endl;

	vector<pair<point, point>> ans;
	vector<int> target(n);
	iota(target.begin(), target.end(), 0);
	ll cur = encode(target);
	assert(from.count(cur));
	while (cur != 0) {
		auto cur_from = from[cur];
		ans.push_back(lines[cur_from.ff]);
		cur = cur_from.ss;
	}

	cout << szof(ans) << "\n";
	for (auto& p : ans) {
		cout << p.ff.x << " " << p.ff.y << " " << p.ss.x << " " << p.ss.y << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
