#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);

	set<pii> edges;

	for (int i = 0; i < m; ++i) {
		int a, b;
		while (true) {
			a = rnd.next(0, n - 1);
			b = rnd.next(0, n - 1);
			if (a < b && !edges.count({a, b})) {
				edges.insert({a, b});
				break;
			}
		}
	}

	vector<vector<int>> graph(n);
	for (auto e : edges) {
		graph[e.ff].push_back(e.ss);
		graph[e.ss].push_back(e.ff);
	}

	vector<bool> used(n);
	vector<int> visited;
	int edges_cnt;

	vector<pii> free_edges;

	function<void(int)> dfs = [&](int v) {
		used[v] = true;
		edges_cnt += szof(graph[v]);
		visited.push_back(v);
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to);
			} else {
				free_edges.push_back({v, to});
			}
		}
	};

	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			edges_cnt = 0;
			visited.clear();
			free_edges.clear();
			dfs(i);
			edges_cnt /= 2;
			if (edges_cnt % 2 == 1) {
				bool found = false;
				for (int tr = 0; tr < 100; ++tr) {
					int a = visited[rnd.next(0, szof(visited) - 1)];
					int b = visited[rnd.next(0, szof(visited) - 1)];
					if (a > b) {
						swap(a, b);
					}
					if (a != b && !edges.count({a, b})) {
						edges.insert({a, b});
						found = true;
						break;
					}
				}

				if (!found) {
					auto [a, b] = free_edges[rnd.next(0, szof(free_edges) - 1)];
					if (a > b) {
						swap(a, b);
					}
					edges.erase({a, b});
				}
			}
		}
	}

	cout << n << " " << szof(edges) << "\n";
	vector<pii> arr_edges(edges.begin(), edges.end());
	shuffle(arr_edges.begin(), arr_edges.end());

	for (auto e : arr_edges) {
		if (rnd.next(0, 1)) {
			swap(e.ff, e.ss);
		}
		cout << e.ff + 1 << " " << e.ss + 1 << "\n";
	}

	return 0;
}