#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int n, vector<pair<int, int>>& test) 
{
    cout << n << ' '  << test.size() << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i].first << ' ' << test[i].second << endl;
}

long long calc_edges(int n) 
{
    return 1ll * n * (n - 1) / 2;
}

vector<pair<int, int>> gen_full_component(int n)
{
    vector<pair<int, int>> e;
    
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)        
        {    
            if (rnd.next(2))
                e.push_back(make_pair(i, j));
            else 
                e.push_back(make_pair(j, i));   
        }   
        
    shuffle(e.begin(), e.end());
    return e;
}


void gen(int n, int c)
{
    assert(n >= c);
    vector<int> cnt_v(c, 1);
    for (int i = c; i < n; i++)
    {
        int v = rnd.next(0, c - 1);
        cnt_v[v]++;
    }    
    
    vector<int> v(n);
    iota(v.begin(), v.end(), 1);
    shuffle(v.begin(), v.end());
    vector<pair<int, int>> e;
    int sum_v = 0;
    for (int i = 0; i < c; i++)
    {
        auto cur_comp = gen_full_component(cnt_v[i]);
        for (pair<int, int> cur_e : cur_comp) {
            e.push_back(make_pair(v[cur_e.first + sum_v], v[cur_e.second + sum_v]));
        }
        sum_v += cnt_v[i];
    }
    shuffle(e.begin(), e.end());
    write_test(n, e);    
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int c = atoi(argv[2]);
    if (argc > 3 && atoi(argv[3]) == 1)
        n = rnd.next(n / 2, n);
    if (argc > 4 && atoi(argv[4]) == 1)
        c = rnd.next(1, n);   
    gen(n, c);
    return 0;
}