#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int n, vector<pair<int, int>>& test) 
{
    cout << n << ' '  << test.size() << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i].first + 1 << ' ' << test[i].second + 1 << endl;
}

long long calc_edges(int n) 
{
    return 1ll * n * (n - 1) / 2;
}

void gen_rand(int n, int m)
{
    vector<pair<int, int>> e;
    
    map<pair<int, int>, bool> used;
    
    for (int i = 0; i < m; i++)
    {
        int cur = rnd.next(0, n - 2);
        int nxt = rnd.next(cur + 1, n - 1);
        int first_cur = cur;
        while (cur == nxt || used[{cur, nxt}])
        {
            if ((cur + 1) % n == first_cur)
                nxt = (nxt + 1) % n;
            else
                cur = (cur + 1) % n;    
        }

        if (!used[{cur, nxt}])
        {
            used[{cur, nxt}] = true;
            used[{nxt, cur}] = true;
            if (rnd.next(2))
                e.push_back(make_pair(cur, nxt));
            else 
                e.push_back(make_pair(nxt, cur));
        }    
    }
    
    shuffle(e.begin(), e.end());
    write_test(n, e);    
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    if (argc > 3 && atoi(argv[3]) == 1)
        n = rnd.next(n / 2, n);
    if (argc > 4 && atoi(argv[4]) == 1)
        m = rnd.next(m / 2, min(n * (n + 1) / 2,  m));
    gen_rand(n, m);
    return 0;
}