#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int n, vector<pair<int, int>>& test) 
{
    cout << n << ' '  << test.size() << endl;
    for (int i = 0; i < (int)test.size(); i++)
        cout << test[i].first + 1 << ' ' << test[i].second + 1 << endl;
}

long long calc_edges(int n) 
{
    return 1ll * n * (n - 1) / 2;
}

int count_edges(int v, const vector<vector<int>> &g, vector<int> &was)
{
    was[v] = 1;
    int res = 0;
    for (int u : g[v])
    {
        res++;
        if (!was[u])
            res += count_edges(u, g, was);
            
    }
    return res;
}

void gen_rand(int n, int m)
{
    vector<pair<int, int>> e;
    vector<vector<int>> g(n);
    
    map<pair<int, int>, bool> used;
    
    for (int i = 0; i < m; i++)
    {
        int cur = rnd.next(0, n - 2);
        int nxt = rnd.next(cur + 1, n - 1);
        int first_cur = cur;
        while (cur == nxt || used[{cur, nxt}])
        {
            if ((cur + 1) % n == first_cur)
                nxt = (nxt + 1) % n;
            else
                cur = (cur + 1) % n;    
        }

        if (!used[{cur, nxt}])
        {
            used[{cur, nxt}] = true;
            used[{nxt, cur}] = true;
            if (rnd.next(2))
                e.push_back(make_pair(cur, nxt));
            else 
                e.push_back(make_pair(nxt, cur));
            g[cur].push_back(nxt);
            g[nxt].push_back(cur);
        }    
    }
    
    vector<int> was(n, 0);
    vector<int> to_del(n, 0);
    for (int i = 0; i < n; i++)
    {
        if (!was[i])
        {
            int cnt = count_edges(i, g, was) / 2;
            if (cnt % 2 == 1)
            {
                to_del[i] = 1; 
                //cerr << i << endl;    
            }    
        }
    }
    vector<pair<int, int>> e_;
    for (auto cur : e)
    {
        if (to_del[cur.first] || to_del[cur.second])
        {    
            to_del[cur.first] = to_del[cur.second] = 0;
            //cerr << cur.first << ' ' << cur.second << endl;
        }
        else
            e_.push_back(cur);
    }
    e = e_;
    shuffle(e.begin(), e.end());
    write_test(n, e);    
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    if (argc > 3 && atoi(argv[3]) == 1)
        n = rnd.next(n / 2, n);
    if (argc > 4 && atoi(argv[4]) == 1)
        m = rnd.next(m / 2, min(n * (n + 1) / 2,  m));
    gen_rand(n, m);
    return 0;
}