#include <iostream>
#include <vector>

using namespace std;

unsigned int dfs(unsigned int v, vector<vector<unsigned int>> const &g, vector<unsigned int> &color) {
    color[v] = 1;
    unsigned int res = 0;
    for (unsigned int u : g[v]) {
        if (!color[u]) {
            res += 1 + dfs(u, g, color);
        } else if (color[u] == 2) {
            res += 1;
        }
    }
    color[v] = 2;
    return res;
}

int main() {

    unsigned int n, m;
    cin >> n >> m;
    vector<vector<unsigned int>> g(n);

    for (unsigned int i = 0; i < m; i++) {
        unsigned int a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        g[b].push_back(a);
    }

    vector<unsigned int> color(n, 0);
    for (unsigned int i = 0; i < n; i++) {
        if (!color[i]) {
            if (dfs(i, g, color) % 2 == 1) {
                cout << "YES\n";
                return 0;
            }
        }
    }

    cout << "NO\n";

}
