#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    unsigned long long k;
    cin >> n >> m >> k;

    vector<unsigned long long> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<pair<unsigned int, int>> views;
    for (unsigned int i = 0; i < m; i++) {
        unsigned int from, to;
        cin >> from >> to;
        views.emplace_back(from - 1, 1);
        views.emplace_back(to, -1);
    }
    sort(views.begin(), views.end(), [](auto const &p1, auto const &p2) {
        return p1.first == p2.first ? p1.second > p2.second : p1.first < p2.first;
    });

    vector<unsigned int> cnt(n);
    unsigned int res = 0, event = 0;
    unsigned long long ans = 0;
    for (unsigned int i = 0; i < n; i++) {
        while (event < views.size() && views[event].first == i) {
            res += views[event++].second;
        }
        ans += a[i] * (cnt[i] = res);
    }

    vector<unsigned int> people(n);
    for (unsigned int i = 0; i < n; i++) {
        people[i] = i;
    }
    sort(people.begin(), people.end(), [&cnt](auto i, auto j) {
        return cnt[i] > cnt[j];
    });

    unsigned int cur = 0;
    while (k > 0 && cur < n) {
        unsigned long long sub = min(k, a[people[cur]]);
        k -= sub;
        ans -= sub * cnt[people[cur++]];
    }

    cout << ans << '\n';

}
