#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    unsigned long long k;
    cin >> n >> m >> k;

    vector<unsigned long long> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<long long> views(n + 1);
    for (unsigned int i = 0; i < m; i++) {
        unsigned int from, to;
        cin >> from >> to;
        views[from - 1]++;
        views[to]--;
    }
    for (unsigned int i = 1; i <= n; i++) {
        views[i] += views[i - 1];
    }

    unsigned int res = 0, event = 0;
    unsigned long long ans = 0;
    for (unsigned int i = 0; i < n; i++) {
        ans += a[i] * (unsigned long long) views[i];
    }

    vector<unsigned int> people(n);
    for (unsigned int i = 0; i < n; i++) {
        people[i] = i;
    }
    sort(people.begin(), people.end(), [&views](auto i, auto j) {
        return views[i] > views[j];
    });

    unsigned int cur = 0;
    while (k > 0 && cur < n) {
        unsigned long long sub = min(k, a[people[cur]]);
        k -= sub;
        ans -= sub * views[people[cur++]];
    }

    cout << ans << '\n';

}
