// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>
#include "testlib.h"

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int dx[4] = { 0,  0, +1, -1};
int dy[4] = {+1, -1,  0,  0};

int main(int argc, char** argv) {
    // code here
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();

    auto check_ans = [&](InStream& str) {
        vector<vector<char>> ok(n, vector<char>(n));

        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            string s = str.readString(format("[.#]{%d}", n));
            
            for (int j = 0; j < n; ++j) {
                ok[i][j] = (s[j] == '.');
                cnt += not ok[i][j];
            }
        }
        
        vector<vector<pair<int, int>>> pair_of(n, vector<pair<int, int>>(n, make_pair(-1, -1)));

        int M = 0;
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                if (ok[i][j] and (i + j) % 2 == 0) {
                    vector<vector<char>> used(n, vector<char>(n));

                    std::function<bool(int, int)> dfs = [&](int x, int y) {
                        used[x][y] = 1;

                        for (int t = 0; t < 4; ++t)
                            if (0 <= min(x + dx[t], y + dy[t]) and max(x + dx[t], y + dy[t]) < n and ok[x + dx[t]][y + dy[t]]) {
                                int px = pair_of[x + dx[t]][y + dy[t]].first;
                                int py = pair_of[x + dx[t]][y + dy[t]].second;

                                if (px == -1 or (not used[px][py] and dfs(px, py))) {
                                    pair_of[x][y] = make_pair(x + dx[t], y + dy[t]);
                                    pair_of[x + dx[t]][y + dy[t]] = make_pair(x, y);
                                    return true;
                                }
                            }

                        return false;
                    };
                    
                    M += dfs(i, j);
                }

        if (2 * M + cnt != n * n)
            str.quitf(_wa, "there is no domino board cover");

        vector<vector<char>> used(n, vector<char>(n, 0));
        std::function<void(int, int)> dfs = [&](int x, int y) {
            if (used[x][y] == 2) {
                return;
            }
            
            if (used[x][y]) {
                str.quitf(_wa, "domino cover is not unique");
            }
            
            used[x][y] = 1;

            for (int t = 0; t != 4; ++t) {
                if (0 <= min(x + dx[t], y + dy[t]) and max(x + dx[t], y + dy[t]) < n and ok[x + dx[t]][y + dy[t]]
                    and pair_of[x][y] != make_pair(x + dx[t], y + dy[t])) {

                    auto pr = pair_of[x + dx[t]][y + dy[t]];
                    dfs(pr.first, pr.second);
                }
            }
            
            used[x][y] = 2;
        };
        
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j)
                if (ok[i][j] and (i + j) % 2 == 0 and used[i][j] == 0) {
                    dfs(i, j);
                }
        }
        
        return cnt;
    };

    int er2 = check_ans(ouf);

    if (er2 > n)
        quitf(_wa, "num of # is %d", er2);
    else
        quitf(_ok, "num of # is %d", er2);
    
    return 0;
}
