#include <iostream>
#include <queue>
#include <cmath>
#include <unordered_map>

using namespace std;

struct node {
    unsigned long long a, b;
    unsigned int step;
};

struct pair_hash {
    template<typename T1, typename T2>
    std::size_t operator()(pair<T1, T2> const &p) const {
        return hash<T1>()(p.first) ^ hash<T2>()(p.second);
    }
};

unsigned long long geom(unsigned long long a, unsigned long long b) {
    return ceil(sqrt((long double) a * b));
}

unsigned long long square(unsigned long long a, unsigned long long b) {
    return floor(sqrt(((long double) a * a + (long double) b * b) / 2));
}

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned long long a, b;
    cin >> a >> b;

    queue<node> q;
    unordered_map<pair<unsigned long long, unsigned long long>, unsigned int, pair_hash> dist;
    dist[{a, b}] = 0;
    q.push({a, b, 0});
    while (true) {
        auto cur = q.front();
        q.pop();
#ifdef LOCAL
//        cout << cur.a << ' ' << cur.b << ' ' << cur.step << '\n';
#endif
        if (cur.a == cur.b) {
            cout << cur.step << '\n';
            return 0;
        }
        unsigned long long g = geom(cur.a, cur.b), s = square(cur.a, cur.b);
        unsigned long long low = min(g, s), high = max(g, s);
        if (dist.count({a, low}) == 0) {
            dist[{a, low}] = cur.step + 1;
            q.push({a, low, cur.step + 1});
        }
        if (dist.count({high, b}) == 0) {
            dist[{high, b}] = cur.step + 1;
            q.push({high, b, cur.step + 1});
        }
    }

}
