#include <iostream>
#include <queue>
#include <cmath>
#include <unordered_map>

using namespace std;

unsigned long long geom(unsigned long long a, unsigned long long b) {
    return ceil(sqrt((long double) a * b));
}

unsigned long long square(unsigned long long a, unsigned long long b) {
    return floor(sqrt(((long double) a * a + (long double) b * b) / 2));
}

unsigned int go_low(unsigned long long a, unsigned long long b) {
    unsigned int step = 0;
    while (a != b) {
        b = min(geom(a, b), square(a, b));
        step++;
    }
    return step;
}

unsigned int go_high(unsigned long long a, unsigned long long b) {
    unsigned int step = 0;
    while (a != b) {
        a = max(geom(a, b), square(a, b));
        step++;
    }
    return step;
}

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned long long a, b;
    cin >> a >> b;
    cout << min(go_low(a, b), go_high(a, b)) << '\n';

}
