// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int calc_geom(int a, int b) {
	ll l = 0, r = 1e7;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		if ((ll) mid * mid < (ll) a * b) {
			l = mid;
		} else {
			r = mid;
		}
	}
	return r;
}

int calc_sqr(int a, int b) {
	ll l = 0, r = 1e7;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		if ((ll) mid * mid * 2 <= (ll) a * a + (ll) b * b) {
			l = mid;
		} else {
			r = mid;
		}
	}
	return l;
}

void solve() {
	int a, b;
	cin >> a >> b;
	queue<pii> qu;
	qu.push({a, b});
	map<pii, int> dist;
	dist[{a, b}] = 0;
	while (szof(qu)) {
		auto [x, y] = qu.front();
		qu.pop();
		int cdist = dist[{x, y}];
		if (x == y) {
			cout << cdist << "\n";
			return;
		}
		int m1 = calc_geom(x, y);
		int m2 = calc_sqr(x, y);
		if (m1 > m2) {
			swap(m1, m2);
		}
		if (!dist.count({x, m1})) {
			dist[{x, m1}] = cdist + 1;
			qu.push({x, m1});
		}
		if (!dist.count({m1, y})) {
			dist[{m1, y}] = cdist + 1;
			qu.push({m1, y});
		}
		if (!dist.count({x, m2})) {
			dist[{x, m2}] = cdist + 1;
			qu.push({x, m2});
		}
		if (!dist.count({m2, y})) {
			dist[{m2, y}] = cdist + 1;
			qu.push({m2, y});
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
