#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 250000;
const int M = 998244353;

int pw[N];
int dsu[N];
int sz[N];
int col[N];
int u[N], v[N];

int get(int v) {
  if (v == dsu[v]) {
    return v;
  } else {
    return get(dsu[v]);
  }
}

int get_col(int v) {
  if (v == dsu[v]) {
    return col[v];
  } else {
    return col[v] ^ get_col(dsu[v]);
  }
}

vector <bool> orz;
vector <pair <int&, int> > was;
int bad_cnt;

void add_edge(int a, int b, int c) {
  if (get(a) != get(b)) {
    int u = a, v = b;
    a = get(a), b = get(b);
    if (sz[a] > sz[b]) {
      swap(a, b);
    }
    was.push_back({dsu[a], dsu[a]});
    was.push_back({sz[b], sz[b]});
    was.push_back({col[a], col[a]});
    dsu[a] = b;
    sz[b] += sz[a];
    if ((get_col(u) ^ get_col(v)) != c) {
      col[a] ^= 1;
    }
  } else {
    was.push_back({bad_cnt, bad_cnt});
    was.push_back({bad_cnt, bad_cnt});
    was.push_back({bad_cnt, bad_cnt});
    if ((get_col(a) ^ get_col(b)) != c) {
      bad_cnt++;
    }
  }
}

void undo() {
  for (int it = 0; it < 3; it++) {
    was.back().first = was.back().second;
    was.pop_back();
  }
}

int value = 1;

void solve(int l, int r) {
  if (r - l == 1) {
    add_edge(u[l], v[l], 1);
    if (!bad_cnt) {
      value++;
    }
    undo();
    return;
  } else {
    int m = (l + r) / 2;
    for (int i = m; i < r; i++) {
      add_edge(u[i], v[i], 1);
    }
    solve(l, m);
    for (int i = m; i < r; i++) {
      undo();
    }
    for (int i = l; i < m; i++) {
      add_edge(u[i], v[i], 0);
    }
    solve(m, r);
    for (int i = l; i < m; i++) {
      undo();
    }
  }
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; i++) {
    dsu[i] = i;
    sz[i] = 1;
  }
  pw[0] = 1;
  for (int i = 1; i < n; i++) {
    pw[i] = pw[i - 1] + pw[i - 1];
    if (pw[i] >= M) {
      pw[i] -= M;
    }
  }
  for (int i = 1; i < n; i++) {
    int par;
    cin >> par;
  }
  for (int i = 0; i < m; i++) {
    cin >> u[i] >> v[i];
    u[i]--, v[i]--;
  }
  solve(0, m);
  int comps = n;
  for (int i = 0; i < m; i++) {
    if (get(u[i]) != get(v[i])) {
      add_edge(u[i], v[i], 0);
      comps--;
    }
  }
  cout << (value * (ll) pw[comps - 1]) % M << '\n';
}
