// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998244353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b >>= 1;
	}
	return ret;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> parent(n, -1);
	for (int i = 1; i < n; ++i) {
		cin >> parent[i];
		--parent[i];
	}
	vector<pii> paths;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		paths.push_back({a, b});
	}

	int bpv = 1;
	while (bpv < m + 1) {
		bpv *= 2;
	}

	vector<vector<pair<pii, int>>> segtree(bpv * 2);

	auto add_edge_on_seg = [&](int l, int r, pair<pii, int> e) {
		l += bpv; r += bpv;
		while (l < r) {
			if (l & 1) {
				segtree[l++].push_back(e);
			}
			if (r & 1) {
				segtree[--r].push_back(e);
			}
			l /= 2; r /= 2;
		}
	};

	for (int i = 0; i < m; ++i) {
		add_edge_on_seg(0, m - i, {paths[i], 0});
		add_edge_on_seg(m - i, m + 1, {paths[i], 1});
	}

	vector<int> dsu(n);
	iota(dsu.begin(), dsu.end(), 0);
	vector<int> sz(n);
	vector<int> flip(n);
	int graph_ok = 1;
	int graph_comps = n;

	vector<pair<int*, int>> changes;

	auto get_root = [&](int v) {
		int val = 0;
		while (dsu[v] != v) {
			val ^= flip[v];
			v = dsu[v];
		}
		return make_pair(v, val);
	};

	auto add_edge = [&](int a, int b, int c) {
		if (!graph_ok) {
			return;
		}
		auto ra = get_root(a);
		auto rb = get_root(b);
		if (ra.ff == rb.ff) {
			if ((ra.ss ^ rb.ss) != c) {
				changes.push_back({&graph_ok, graph_ok});
				graph_ok = 0;
				return;
			}
		} else {
			changes.push_back({&graph_comps, graph_comps});
			--graph_comps;
			if (sz[ra.ff] > sz[rb.ff]) {
				swap(ra, rb);
			}
			changes.push_back({&dsu[ra.ff], dsu[ra.ff]});
			dsu[ra.ff] = rb.ff;
			changes.push_back({&flip[ra.ff], flip[ra.ff]});
			flip[ra.ff] = c ^ ra.ss ^ rb.ss;
			if (sz[ra.ff] == sz[rb.ff]) {
				changes.push_back({&sz[rb.ff], sz[rb.ff]});
				sz[rb.ff]++;
			}
		}
	};

	int ans = 0;

	function<void(int)> dfs = [&](int v) {
		int mem = szof(changes);
		for (auto e : segtree[v]) {
			add_edge(e.ff.ff, e.ff.ss, e.ss);
		}

		if (bpv <= v) {
			if (v < bpv + m + 1 && graph_ok) {
				add(ans, mpow(2, graph_comps - 1));
			}
		} else {
			dfs(v * 2);
			dfs(v * 2 + 1);
		}

		while (szof(changes) > mem) {
			*changes.back().ff = changes.back().ss;
			changes.pop_back();
		}
	};

	dfs(1);

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
